/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.openejb.config;

import org.apache.openejb.jee.AssemblyDescriptor;
import org.apache.openejb.jee.EjbJar;
import org.apache.openejb.jee.EnterpriseBean;
import org.apache.openejb.jee.Interceptor;

public class EmptyEjbJar extends EjbJar {
    @Override
    public void setAssemblyDescriptor(final AssemblyDescriptor value) {
        // no-op
    }

    @Override
    public void setEnterpriseBeans(final EnterpriseBean[] v) {
        // no-op
    }

    @Override
    public EnterpriseBean[] getEnterpriseBeans() {
        return super.getEnterpriseBeans();
    }

    @Override
    public <T extends EnterpriseBean> T addEnterpriseBean(final T bean) {
        if (CompManagedBean.class.isInstance(bean)) {
            super.addEnterpriseBean(bean);
        }
        return bean;
    }

    @Override
    public <T extends EnterpriseBean> EjbJar enterpriseBean(final T bean) {
        return this;
    }

    @Override
    public Interceptor addInterceptor(final Interceptor interceptor) {
        return interceptor;
    }
}
