/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.openejb.jee.jba;

import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlRootElement;
import jakarta.xml.bind.annotation.XmlType;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "methodName",
    "readOnly",
    "idempotent",
    "transactionTimeout"
})
@XmlRootElement(name = "method")
public class Method {

    @XmlElement(name = "method-name", required = true)
    protected String methodName;
    @XmlElement(name = "read-only")
    protected String readOnly;
    protected String idempotent;
    @XmlElement(name = "transaction-timeout")
    protected String transactionTimeout;

    /**
     * Gets the value of the methodName property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getMethodName() {
        return methodName;
    }

    /**
     * Sets the value of the methodName property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setMethodName(final String value) {
        this.methodName = value;
    }

    /**
     * Gets the value of the readOnly property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getReadOnly() {
        return readOnly;
    }

    /**
     * Sets the value of the readOnly property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setReadOnly(final String value) {
        this.readOnly = value;
    }

    /**
     * Gets the value of the idempotent property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getIdempotent() {
        return idempotent;
    }

    /**
     * Sets the value of the idempotent property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setIdempotent(final String value) {
        this.idempotent = value;
    }

    /**
     * Gets the value of the transactionTimeout property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getTransactionTimeout() {
        return transactionTimeout;
    }

    /**
     * Sets the value of the transactionTimeout property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setTransactionTimeout(final String value) {
        this.transactionTimeout = value;
    }

}
