/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.openejb.jee.jba;

import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlRootElement;
import jakarta.xml.bind.annotation.XmlType;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "serviceRefName",
    "configName",
    "configFile",
    "wsdlOverride"
})
@XmlRootElement(name = "service-ref")
public class ServiceRef {

    @XmlElement(name = "service-ref-name", required = true)
    protected String serviceRefName;
    @XmlElement(name = "config-name")
    protected String configName;
    @XmlElement(name = "config-file")
    protected String configFile;
    @XmlElement(name = "wsdl-override")
    protected String wsdlOverride;

    /**
     * Gets the value of the serviceRefName property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getServiceRefName() {
        return serviceRefName;
    }

    /**
     * Sets the value of the serviceRefName property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setServiceRefName(final String value) {
        this.serviceRefName = value;
    }

    /**
     * Gets the value of the configName property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getConfigName() {
        return configName;
    }

    /**
     * Sets the value of the configName property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setConfigName(final String value) {
        this.configName = value;
    }

    /**
     * Gets the value of the configFile property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getConfigFile() {
        return configFile;
    }

    /**
     * Sets the value of the configFile property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setConfigFile(final String value) {
        this.configFile = value;
    }

    /**
     * Gets the value of the wsdlOverride property.
     *
     * @return possible object is
     * {@link String }
     */
    public String getWsdlOverride() {
        return wsdlOverride;
    }

    /**
     * Sets the value of the wsdlOverride property.
     *
     * @param value allowed object is
     *              {@link String }
     */
    public void setWsdlOverride(final String value) {
        this.wsdlOverride = value;
    }

}
