/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.apache.tomee.microprofile.jwt.bval.blue;

import org.apache.tomee.microprofile.jwt.bval.Generated;
import org.apache.tomee.microprofile.jwt.bval.green.TokenValidation;
import org.eclipse.microprofile.jwt.JsonWebToken;

import java.net.URI;
import java.util.List;


public class Blue$$JwtConstraints {

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final boolean b) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final byte b) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final char c) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final double n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final float n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final int n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/URIs")
    public JsonWebToken sapphire(final int n, final URI... array) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final URI uri) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/boolean")
    public JsonWebToken sapphire(final URI uri, final boolean b) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/byte")
    public JsonWebToken sapphire(final URI uri, final byte b) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/char")
    public JsonWebToken sapphire(final URI uri, final char c) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/double")
    public JsonWebToken sapphire(final URI uri, final double n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/float")
    public JsonWebToken sapphire(final URI uri, final float n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/int")
    public JsonWebToken sapphire(final URI uri, final int n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/URI")
    public JsonWebToken sapphire(final URI uri, final URI uri2) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/long")
    public JsonWebToken sapphire(final URI uri, final long n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/short")
    public JsonWebToken sapphire(final URI uri, final short n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/URIs")
    public JsonWebToken sapphire(final URI... array) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com/URI")
    public JsonWebToken sapphire(final List list, final URI uri) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final long n) {
        return null;
    }

    @Generated("org.apache.tomee.microprofile.jwt.bval.JwtValidationGenerator")
    @TokenValidation("http://foo.bar.com")
    public JsonWebToken sapphire(final short n) {
        return null;
    }
}
